function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import React from 'react';
import { shallow } from 'enzyme';
import { StyledRoot, StyledCalendarContainer, StyledHeader, StyledMonthHeader, StyledMonth, StyledWeek, StyledDay } from '../index.js';
var styledComponents = [[StyledRoot, 'StyledRoot'], [StyledCalendarContainer, 'StyledCalendarContainer'], [StyledHeader, 'StyledHeader'], [StyledMonthHeader, 'StyledMonthHeader'], [StyledMonth, 'StyledMonth'], [StyledWeek, 'StyledWeek'], [StyledDay, 'StyledDay']];
var props = [['$disabled'], ['$isHighlighted'], ['$isHovered'], ['$outsideMonth'], ['$selected']];
describe('Component styled components', function () {
  test.each(styledComponents)('Basic render', function (Component, name) {
    var component = shallow(React.createElement(Component, null));
    expect(component.instance().getStyles()).toMatchSnapshot("".concat(name, " has correct styles"));
  });
  test.each(props)('Prop based styles', function (prop) {
    var component = shallow(React.createElement(StyledDay, _defineProperty({}, prop, true)));
    expect(component.instance().getStyles()).toMatchSnapshot("StyledDay has correct styles when ".concat(prop, " is set to true"));
  });
});